using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using Genghis.Windows.Forms;

namespace CoolMenu
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private System.Windows.Forms.MainMenu mainMenu1;
		private System.Windows.Forms.MenuItem menuItem1;
		private System.Windows.Forms.MenuItem menuItem2;
		private System.Windows.Forms.MenuItem menuItem3;
		private System.Windows.Forms.MenuItem menuItem4;
		private System.Windows.Forms.MenuItem menuItem5;
		private System.Windows.Forms.MenuItem menuItem6;
		private System.Windows.Forms.MenuItem menuItem7;
		private System.Windows.Forms.MenuItem menuItem8;
		private System.Windows.Forms.MenuItem menuItem9;
		private System.Windows.Forms.MenuItem menuItem10;
		private System.Windows.Forms.MenuItem menuItem11;
		private System.Windows.Forms.MenuItem menuItem12;
		private System.Windows.Forms.MenuItem menuItem13;
		private System.Windows.Forms.MenuItem menuItem14;
		private System.Windows.Forms.MenuItem menuItem15;
		private System.Windows.Forms.MenuItem menuItem16;
		private System.Windows.Forms.MenuItem menuItem17;
		private System.Windows.Forms.RadioButton radioButton1;
		private System.Windows.Forms.RadioButton radioButton2;

		private CoolMainMenu coolMainMenu;

		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			// Initialize cool menu from standard menu.
			coolMainMenu = new CoolMainMenu(mainMenu1);

			// Load menu images.
			System.IO.Stream stream = this.GetType().Assembly.GetManifestResourceStream("CoolMenu.Standard16.png");
			if (stream == null)
				throw new ArgumentException("The specified resource does not exist: CoolMenu.Standard16.png");
			Image images = Image.FromStream(stream);

			// Assign images to menu items.
			((CoolMenuItem) coolMainMenu.MenuItems[0].MenuItems[0]).Image = GetMenuImage(images, 0, new Size(16, 16));
			((CoolMenuItem) coolMainMenu.MenuItems[0].MenuItems[1]).Image = GetMenuImage(images, 1, new Size(16, 16));
			((CoolMenuItem) coolMainMenu.MenuItems[0].MenuItems[2]).Image = GetMenuImage(images, 2, new Size(16, 16));
			((CoolMenuItem) coolMainMenu.MenuItems[0].MenuItems[3]).Image = GetMenuImage(images, 6, new Size(16, 16));
			((CoolMenuItem) coolMainMenu.MenuItems[1].MenuItems[0]).Image = GetMenuImage(images, 3, new Size(16, 16));
			((CoolMenuItem) coolMainMenu.MenuItems[1].MenuItems[1]).Image = GetMenuImage(images, 4, new Size(16, 16));
			((CoolMenuItem) coolMainMenu.MenuItems[1].MenuItems[2]).Image = GetMenuImage(images, 5, new Size(16, 16));
			images.Dispose();
		}

		private Image GetMenuImage(Image images, int index, Size size) 
		{
			Image image = new Bitmap(size.Width, size.Height);
			Graphics graphics = Graphics.FromImage(image);
			graphics.DrawImage(images, 0, 0, new Rectangle(new Point(index * size.Width, 0), size), GraphicsUnit.Pixel);
			graphics.Dispose();

			return image;
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.mainMenu1 = new System.Windows.Forms.MainMenu();
			this.menuItem1 = new System.Windows.Forms.MenuItem();
			this.menuItem4 = new System.Windows.Forms.MenuItem();
			this.menuItem5 = new System.Windows.Forms.MenuItem();
			this.menuItem6 = new System.Windows.Forms.MenuItem();
			this.menuItem7 = new System.Windows.Forms.MenuItem();
			this.menuItem8 = new System.Windows.Forms.MenuItem();
			this.menuItem9 = new System.Windows.Forms.MenuItem();
			this.menuItem10 = new System.Windows.Forms.MenuItem();
			this.menuItem11 = new System.Windows.Forms.MenuItem();
			this.menuItem2 = new System.Windows.Forms.MenuItem();
			this.menuItem15 = new System.Windows.Forms.MenuItem();
			this.menuItem16 = new System.Windows.Forms.MenuItem();
			this.menuItem17 = new System.Windows.Forms.MenuItem();
			this.menuItem3 = new System.Windows.Forms.MenuItem();
			this.menuItem14 = new System.Windows.Forms.MenuItem();
			this.menuItem12 = new System.Windows.Forms.MenuItem();
			this.menuItem13 = new System.Windows.Forms.MenuItem();
			this.radioButton1 = new System.Windows.Forms.RadioButton();
			this.radioButton2 = new System.Windows.Forms.RadioButton();
			this.SuspendLayout();
			// 
			// mainMenu1
			// 
			this.mainMenu1.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					  this.menuItem1,
																					  this.menuItem8,
																					  this.menuItem2});
			// 
			// menuItem1
			// 
			this.menuItem1.Index = 0;
			this.menuItem1.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					  this.menuItem4,
																					  this.menuItem5,
																					  this.menuItem6,
																					  this.menuItem7});
			this.menuItem1.Text = "File";
			// 
			// menuItem4
			// 
			this.menuItem4.Index = 0;
			this.menuItem4.Shortcut = System.Windows.Forms.Shortcut.CtrlN;
			this.menuItem4.Text = "New";
			// 
			// menuItem5
			// 
			this.menuItem5.Index = 1;
			this.menuItem5.Shortcut = System.Windows.Forms.Shortcut.CtrlO;
			this.menuItem5.Text = "Open";
			// 
			// menuItem6
			// 
			this.menuItem6.Index = 2;
			this.menuItem6.Shortcut = System.Windows.Forms.Shortcut.CtrlS;
			this.menuItem6.Text = "Save";
			// 
			// menuItem7
			// 
			this.menuItem7.Index = 3;
			this.menuItem7.Text = "Exit";
			// 
			// menuItem8
			// 
			this.menuItem8.Index = 1;
			this.menuItem8.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					  this.menuItem9,
																					  this.menuItem10,
																					  this.menuItem11});
			this.menuItem8.Text = "Edit";
			// 
			// menuItem9
			// 
			this.menuItem9.Index = 0;
			this.menuItem9.Shortcut = System.Windows.Forms.Shortcut.CtrlX;
			this.menuItem9.Text = "Cut";
			// 
			// menuItem10
			// 
			this.menuItem10.Index = 1;
			this.menuItem10.Shortcut = System.Windows.Forms.Shortcut.CtrlC;
			this.menuItem10.Text = "Copy";
			// 
			// menuItem11
			// 
			this.menuItem11.Index = 2;
			this.menuItem11.Shortcut = System.Windows.Forms.Shortcut.CtrlV;
			this.menuItem11.Text = "Paste";
			// 
			// menuItem2
			// 
			this.menuItem2.Index = 2;
			this.menuItem2.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					  this.menuItem15,
																					  this.menuItem3,
																					  this.menuItem14,
																					  this.menuItem12,
																					  this.menuItem13});
			this.menuItem2.Text = "View";
			// 
			// menuItem15
			// 
			this.menuItem15.Index = 0;
			this.menuItem15.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					   this.menuItem16,
																					   this.menuItem17});
			this.menuItem15.Text = "Toolbar";
			// 
			// menuItem16
			// 
			this.menuItem16.Checked = true;
			this.menuItem16.Index = 0;
			this.menuItem16.Text = "Standard";
			// 
			// menuItem17
			// 
			this.menuItem17.Index = 1;
			this.menuItem17.Text = "Super Duper";
			// 
			// menuItem3
			// 
			this.menuItem3.Checked = true;
			this.menuItem3.Index = 1;
			this.menuItem3.Text = "Status Bar";
			// 
			// menuItem14
			// 
			this.menuItem14.Index = 2;
			this.menuItem14.Text = "-";
			// 
			// menuItem12
			// 
			this.menuItem12.Checked = true;
			this.menuItem12.Index = 3;
			this.menuItem12.RadioCheck = true;
			this.menuItem12.Text = "Page 1";
			// 
			// menuItem13
			// 
			this.menuItem13.Index = 4;
			this.menuItem13.RadioCheck = true;
			this.menuItem13.Text = "Page 2";
			// 
			// radioButton1
			// 
			this.radioButton1.Checked = true;
			this.radioButton1.Location = new System.Drawing.Point(16, 24);
			this.radioButton1.Name = "radioButton1";
			this.radioButton1.Size = new System.Drawing.Size(232, 32);
			this.radioButton1.TabIndex = 0;
			this.radioButton1.TabStop = true;
			this.radioButton1.Text = "Use standard menus.";
			this.radioButton1.CheckedChanged += new System.EventHandler(this.radioButton1_CheckedChanged);
			// 
			// radioButton2
			// 
			this.radioButton2.Location = new System.Drawing.Point(16, 72);
			this.radioButton2.Name = "radioButton2";
			this.radioButton2.Size = new System.Drawing.Size(232, 32);
			this.radioButton2.TabIndex = 1;
			this.radioButton2.Text = "Use CoolMenus!";
			this.radioButton2.CheckedChanged += new System.EventHandler(this.radioButton2_CheckedChanged);
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(256, 129);
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		  this.radioButton2,
																		  this.radioButton1});
			this.Menu = this.mainMenu1;
			this.Name = "Form1";
			this.Text = "CoolMenu Sample";
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

		private void radioButton1_CheckedChanged(object sender, System.EventArgs e)
		{
			// Switch to using normal menus.
			this.Menu = mainMenu1;
		}

		private void radioButton2_CheckedChanged(object sender, System.EventArgs e)
		{
			// Switch to using cool menus.
			this.Menu = coolMainMenu;
		}
	}
}
