using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.Threading;
using System.Reflection;
using Genghis.Windows.Forms;

namespace GenghisCursorChangerSample
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class mainForm : System.Windows.Forms.Form
	{
    private System.Windows.Forms.Button testBtn;
    private System.Windows.Forms.NumericUpDown secondSpinner;
    private System.Windows.Forms.ComboBox cursorCombo;
    private System.Windows.Forms.Label label1;
    private System.Windows.Forms.Label label2;
    private PropertyInfo[] cursors;
    /// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public mainForm()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
      this.testBtn = new System.Windows.Forms.Button();
      this.secondSpinner = new System.Windows.Forms.NumericUpDown();
      this.cursorCombo = new System.Windows.Forms.ComboBox();
      this.label1 = new System.Windows.Forms.Label();
      this.label2 = new System.Windows.Forms.Label();
      ((System.ComponentModel.ISupportInitialize)(this.secondSpinner)).BeginInit();
      this.SuspendLayout();
      // 
      // testBtn
      // 
      this.testBtn.Location = new System.Drawing.Point(88, 64);
      this.testBtn.Name = "testBtn";
      this.testBtn.TabIndex = 2;
      this.testBtn.Text = "Test";
      this.testBtn.Click += new System.EventHandler(this.testBtn_Click);
      // 
      // secondSpinner
      // 
      this.secondSpinner.Location = new System.Drawing.Point(80, 32);
      this.secondSpinner.Name = "secondSpinner";
      this.secondSpinner.Size = new System.Drawing.Size(160, 20);
      this.secondSpinner.TabIndex = 1;
      this.secondSpinner.Value = new System.Decimal(new int[] {
                                                                2,
                                                                0,
                                                                0,
                                                                0});
      // 
      // cursorCombo
      // 
      this.cursorCombo.Location = new System.Drawing.Point(80, 8);
      this.cursorCombo.Name = "cursorCombo";
      this.cursorCombo.Size = new System.Drawing.Size(160, 21);
      this.cursorCombo.Sorted = true;
      this.cursorCombo.TabIndex = 0;
      this.cursorCombo.Text = "cursorCombo";
      // 
      // label1
      // 
      this.label1.Location = new System.Drawing.Point(8, 8);
      this.label1.Name = "label1";
      this.label1.Size = new System.Drawing.Size(48, 16);
      this.label1.TabIndex = 3;
      this.label1.Text = "Cursor:";
      // 
      // label2
      // 
      this.label2.Location = new System.Drawing.Point(8, 32);
      this.label2.Name = "label2";
      this.label2.Size = new System.Drawing.Size(64, 16);
      this.label2.TabIndex = 4;
      this.label2.Text = "Wait (secs):";
      // 
      // mainForm
      // 
      this.AcceptButton = this.testBtn;
      this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
      this.ClientSize = new System.Drawing.Size(248, 94);
      this.Controls.AddRange(new System.Windows.Forms.Control[] {
                                                                  this.label2,
                                                                  this.label1,
                                                                  this.cursorCombo,
                                                                  this.secondSpinner,
                                                                  this.testBtn});
      this.Name = "mainForm";
      this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
      this.Text = "CursorChanger Sample";
      this.Load += new System.EventHandler(this.mainForm_Load);
      ((System.ComponentModel.ISupportInitialize)(this.secondSpinner)).EndInit();
      this.ResumeLayout(false);

    }
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new mainForm());
		}



    private void mainForm_Load(object sender, System.EventArgs e)
    {
      // Using reflection to get the list of possible cursors
      Type cursorType = typeof(Cursors);
      cursors = cursorType.GetProperties(BindingFlags.Static | BindingFlags.GetProperty | BindingFlags.Public);

      // Binding the array of Cursor's to the combobox for easy retrieval
      /* Mike Marshall - 04/28/02 - doesn't work under VS.NET 2003, we'll hard code
       * the types for now
      cursorCombo.DataSource = cursors;
      cursorCombo.DisplayMember = "Name";*/

        
      cursorCombo.Items.Add(Cursors.AppStarting);
      cursorCombo.Items.Add(Cursors.Arrow);
      cursorCombo.Items.Add(Cursors.Cross);
      cursorCombo.Items.Add(Cursors.Default);
      cursorCombo.Items.Add(Cursors.Hand);
      cursorCombo.Items.Add(Cursors.Help);
      cursorCombo.Items.Add(Cursors.HSplit);
      cursorCombo.Items.Add(Cursors.IBeam);
      cursorCombo.Items.Add(Cursors.No);
      cursorCombo.Items.Add(Cursors.NoMove2D);
      cursorCombo.Items.Add(Cursors.NoMoveHoriz);
      cursorCombo.Items.Add(Cursors.NoMoveVert);
      cursorCombo.Items.Add(Cursors.PanEast);
      cursorCombo.Items.Add(Cursors.PanNE);
      cursorCombo.Items.Add(Cursors.PanNorth);
      cursorCombo.Items.Add(Cursors.PanNW);
      cursorCombo.Items.Add(Cursors.PanSE);
      cursorCombo.Items.Add(Cursors.PanSouth);
      cursorCombo.Items.Add(Cursors.PanSW);
      cursorCombo.Items.Add(Cursors.PanWest);
      cursorCombo.Items.Add(Cursors.SizeAll);
      cursorCombo.Items.Add(Cursors.SizeNESW);
      cursorCombo.Items.Add(Cursors.SizeNS);
      cursorCombo.Items.Add(Cursors.SizeNWSE);
      cursorCombo.Items.Add(Cursors.SizeWE);
      cursorCombo.Items.Add(Cursors.UpArrow);
      cursorCombo.Items.Add(Cursors.VSplit);
      cursorCombo.Items.Add(Cursors.WaitCursor);

      // Selecting the Wait Cursor (should always be last)
      cursorCombo.SelectedIndex = cursorCombo.Items.Count - 1;
    }

    private void testBtn_Click(object sender, System.EventArgs e)
    {
       /* MJM 4/28/03 - doesn't work in VS.NET 2003, see mainForm_Load 
      // Using a Property Info on the Cursors to invoke the Selected Cursor
      PropertyInfo propInfo = cursorCombo.SelectedItem as PropertyInfo;

      // Creating a new CursorChanger so that within the using scope, the cursor
      // will be changed to our selected cursor
    
      using (new CursorChanger(propInfo.GetGetMethod().Invoke(null, null) as Cursor))
      {
        // Sleep for as long as the user wants
        Thread.Sleep(Convert.ToInt32(this.secondSpinner.Value) * 1000);
      }*/
      Cursor selectedCursor = cursorCombo.SelectedItem as Cursor;
      using (new CursorChanger(selectedCursor))
      {
         Thread.Sleep(Convert.ToInt32(this.secondSpinner.Value) * 1000);
      }
    }
	}
}
