using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using Genghis.Windows.Forms;

namespace CustomStateTreeViewTest
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
        private System.Windows.Forms.ImageList _arrowsImageList;
        private CustomStateTreeView _customStateTreeView;
        private System.Windows.Forms.ImageList _16ColorImageList;
        private System.Windows.Forms.ImageList _256ColorImageList;
        private System.ComponentModel.IContainer components;

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
            this.components = new System.ComponentModel.Container();
            System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(Form1));
            this._16ColorImageList = new System.Windows.Forms.ImageList(this.components);
            this._arrowsImageList = new System.Windows.Forms.ImageList(this.components);
            this._customStateTreeView = new Genghis.Windows.Forms.CustomStateTreeView();
            this._256ColorImageList = new System.Windows.Forms.ImageList(this.components);
            this.SuspendLayout();
            // 
            // _16ColorImageList
            // 
            this._16ColorImageList.ColorDepth = System.Windows.Forms.ColorDepth.Depth8Bit;
            this._16ColorImageList.ImageSize = new System.Drawing.Size(16, 16);
            this._16ColorImageList.ImageStream = ((System.Windows.Forms.ImageListStreamer)(resources.GetObject("_16ColorImageList.ImageStream")));
            this._16ColorImageList.TransparentColor = System.Drawing.Color.Transparent;
            // 
            // _arrowsImageList
            // 
            this._arrowsImageList.ColorDepth = System.Windows.Forms.ColorDepth.Depth8Bit;
            this._arrowsImageList.ImageSize = new System.Drawing.Size(16, 16);
            this._arrowsImageList.ImageStream = ((System.Windows.Forms.ImageListStreamer)(resources.GetObject("_arrowsImageList.ImageStream")));
            this._arrowsImageList.TransparentColor = System.Drawing.Color.Transparent;
            // 
            // _customStateTreeView
            // 
            this._customStateTreeView.CheckBoxes = true;
            this._customStateTreeView.CheckStateImageList = this._16ColorImageList;
            this._customStateTreeView.Dock = System.Windows.Forms.DockStyle.Fill;
            this._customStateTreeView.ImageIndex = -1;
            this._customStateTreeView.Name = "_customStateTreeView";
            this._customStateTreeView.SelectedImageIndex = -1;
            this._customStateTreeView.Size = new System.Drawing.Size(280, 86);
            this._customStateTreeView.TabIndex = 0;
            // 
            // _256ColorImageList
            // 
            this._256ColorImageList.ColorDepth = System.Windows.Forms.ColorDepth.Depth8Bit;
            this._256ColorImageList.ImageSize = new System.Drawing.Size(16, 16);
            this._256ColorImageList.ImageStream = ((System.Windows.Forms.ImageListStreamer)(resources.GetObject("_256ColorImageList.ImageStream")));
            this._256ColorImageList.TransparentColor = System.Drawing.Color.Transparent;
            // 
            // Form1
            // 
            this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
            this.ClientSize = new System.Drawing.Size(280, 86);
            this.Controls.AddRange(new System.Windows.Forms.Control[] {
                                                                          this._customStateTreeView});
            this.Name = "Form1";
            this.Text = "CustomStateTreeView Test";
            this.Load += new System.EventHandler(this.Form1_Load);
            this.ResumeLayout(false);

        }
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

        private void Form1_Load(object sender, System.EventArgs e)
        {
            TreeNode node0 = _customStateTreeView.Nodes.Add("None");
            _customStateTreeView.SetCheckState(node0, 0);

            TreeNode node1 = _customStateTreeView.Nodes.Add("Unchecked");
            _customStateTreeView.SetCheckState(node1, 1);

            TreeNode node2 = _customStateTreeView.Nodes.Add("Checked");
            _customStateTreeView.SetCheckState(node2, 2);

            TreeNode node3 = _customStateTreeView.Nodes.Add("Indeterminate");
            _customStateTreeView.SetCheckState(node3, 3);
        }
	}
}














