using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using Genghis.Windows.Forms;

namespace FileDocumentTest
{
	/// <summary>
	/// Summary description for ChildForm.
	/// </summary>
	public class ChildForm : System.Windows.Forms.Form
	{
        private System.Windows.Forms.MainMenu mainMenu1;
        private System.Windows.Forms.MenuItem menuItem1;
        private System.Windows.Forms.TextBox textBox1;
        private FileDocument _fileDocument;
        private System.Windows.Forms.MenuItem _fileSaveMenuItem;
        private System.Windows.Forms.MenuItem _fileSaveAsMenuItem;
        private System.Windows.Forms.MenuItem _fileCloseMenuItem;
        private System.ComponentModel.IContainer components;

		public ChildForm()
		{
			// Required for Windows Form Designer support
			InitializeComponent();
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
            this.components = new System.ComponentModel.Container();
            this.mainMenu1 = new System.Windows.Forms.MainMenu();
            this.menuItem1 = new System.Windows.Forms.MenuItem();
            this._fileSaveMenuItem = new System.Windows.Forms.MenuItem();
            this._fileSaveAsMenuItem = new System.Windows.Forms.MenuItem();
            this._fileCloseMenuItem = new System.Windows.Forms.MenuItem();
            this.textBox1 = new System.Windows.Forms.TextBox();
            this._fileDocument = new FileDocument(this.components);
            this.SuspendLayout();
            // 
            // mainMenu1
            // 
            this.mainMenu1.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
                                                                                      this.menuItem1});
            // 
            // menuItem1
            // 
            this.menuItem1.Index = 0;
            this.menuItem1.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
                                                                                      this._fileSaveMenuItem,
                                                                                      this._fileSaveAsMenuItem,
                                                                                      this._fileCloseMenuItem});
            this.menuItem1.MergeType = System.Windows.Forms.MenuMerge.MergeItems;
            this.menuItem1.Text = "&File";
            // 
            // _fileSaveMenuItem
            // 
            this._fileSaveMenuItem.Index = 0;
            this._fileSaveMenuItem.MergeOrder = 1;
            this._fileSaveMenuItem.Shortcut = System.Windows.Forms.Shortcut.CtrlS;
            this._fileSaveMenuItem.Text = "&Save";
            // 
            // _fileSaveAsMenuItem
            // 
            this._fileSaveAsMenuItem.Index = 1;
            this._fileSaveAsMenuItem.MergeOrder = 1;
            this._fileSaveAsMenuItem.Text = "Save &As...";
            // 
            // _fileCloseMenuItem
            // 
            this._fileCloseMenuItem.Index = 2;
            this._fileCloseMenuItem.Text = "&Close";
            // 
            // textBox1
            // 
            this.textBox1.Dock = System.Windows.Forms.DockStyle.Fill;
            this.textBox1.Multiline = true;
            this.textBox1.Name = "textBox1";
            this.textBox1.Size = new System.Drawing.Size(292, 266);
            this.textBox1.TabIndex = 0;
            this.textBox1.Text = "";
            this.textBox1.TextChanged += new System.EventHandler(this.textBox1_TextChanged);
            // 
            // _fileDocument
            // 
            this._fileDocument.DefaultExt = "dnp";
            this._fileDocument.FileCloseMenuItem = this._fileCloseMenuItem;
            this._fileDocument.FileName = "";
            this._fileDocument.FileSaveAsMenuItem = this._fileSaveAsMenuItem;
            this._fileDocument.FileSaveMenuItem = this._fileSaveMenuItem;
            this._fileDocument.HostingForm = this;
            // 
            // ChildForm
            // 
            this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
            this.ClientSize = new System.Drawing.Size(292, 266);
            this.Controls.AddRange(new System.Windows.Forms.Control[] {
                                                                          this.textBox1});
            this.Menu = this.mainMenu1;
            this.Name = "ChildForm";
            this.Text = "ChildForm";
            this.Load += new System.EventHandler(this.ChildForm_Load);
            this.ResumeLayout(false);

        }
		#endregion

        private void textBox1_TextChanged(object sender, System.EventArgs e)
        {
            _fileDocument.Dirty = true;
        }

        // From parent menu/toolbar
        public bool NewDocument()
        {
            if( !_fileDocument.New() ) return false;

            // Let the FileDocument know the data to read/write
            // NOTE: We're wrapping the textbox that actually holds the data
            // to avoid replicating the data from the textbox every time
            // the textbox changes.
            _fileDocument.Data = new TextBoxData(textBox1);
            return true;
        }

        // From parent menu/toolbar
        public bool OpenDocument()
        {
            // Open a new document
            if( !_fileDocument.Open() )
            {
                Close();
                return false;
            }

            // Set the TextBox associated with the data
            ((TextBoxData)_fileDocument.Data).TextBox = textBox1;

            // NOTE: We need to clear the dirty bit manually
            // because setting the text from the TextBoxData
            // object will trigger the TextChange event
            _fileDocument.Dirty = false;

            return true;
        }
    
        // From parent toolbar
        public bool SaveDocument()
        {
            return _fileDocument.Save();
        }

        private void ChildForm_Load(object sender, System.EventArgs e)
        {
            textBox1.Focus();
        }
    }
}
