using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.Diagnostics;
using Genghis.Windows.Forms;

namespace FileDocumentTest
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class MainForm : System.Windows.Forms.Form
	{
        private System.Windows.Forms.MainMenu mainMenu1;
        private System.Windows.Forms.MenuItem menuItem1;
        private System.Windows.Forms.MenuItem menuItem4;
        private System.Windows.Forms.MenuItem menuItem6;
        private System.Windows.Forms.MenuItem fileNewMenuItem;
        private System.Windows.Forms.MenuItem fileOpenMenuItem;
        private System.Windows.Forms.MenuItem fileExitMenuItem;
        private System.Windows.Forms.MenuItem helpAboutMenuItem;
        private System.Windows.Forms.ToolBar toolBar1;
        private System.Windows.Forms.ToolBarButton _newButton;
        private System.Windows.Forms.ToolBarButton _openButton;
        private System.Windows.Forms.ToolBarButton _saveButton;
        private System.ComponentModel.IContainer components;

		public MainForm()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}


        /// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		
        #region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
            this.mainMenu1 = new System.Windows.Forms.MainMenu();
            this.menuItem1 = new System.Windows.Forms.MenuItem();
            this.fileNewMenuItem = new System.Windows.Forms.MenuItem();
            this.fileOpenMenuItem = new System.Windows.Forms.MenuItem();
            this.menuItem4 = new System.Windows.Forms.MenuItem();
            this.fileExitMenuItem = new System.Windows.Forms.MenuItem();
            this.menuItem6 = new System.Windows.Forms.MenuItem();
            this.helpAboutMenuItem = new System.Windows.Forms.MenuItem();
            this.toolBar1 = new System.Windows.Forms.ToolBar();
            this._newButton = new System.Windows.Forms.ToolBarButton();
            this._openButton = new System.Windows.Forms.ToolBarButton();
            this._saveButton = new System.Windows.Forms.ToolBarButton();
            this.SuspendLayout();
            // 
            // mainMenu1
            // 
            this.mainMenu1.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
                                                                                      this.menuItem1,
                                                                                      this.menuItem6});
            // 
            // menuItem1
            // 
            this.menuItem1.Index = 0;
            this.menuItem1.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
                                                                                      this.fileNewMenuItem,
                                                                                      this.fileOpenMenuItem,
                                                                                      this.menuItem4,
                                                                                      this.fileExitMenuItem});
            this.menuItem1.MergeType = System.Windows.Forms.MenuMerge.MergeItems;
            this.menuItem1.Text = "&File";
            // 
            // fileNewMenuItem
            // 
            this.fileNewMenuItem.Index = 0;
            this.fileNewMenuItem.Shortcut = System.Windows.Forms.Shortcut.CtrlN;
            this.fileNewMenuItem.Text = "&New";
            this.fileNewMenuItem.Click += new System.EventHandler(this.fileNewMenuItem_Click);
            // 
            // fileOpenMenuItem
            // 
            this.fileOpenMenuItem.Index = 1;
            this.fileOpenMenuItem.Shortcut = System.Windows.Forms.Shortcut.CtrlO;
            this.fileOpenMenuItem.Text = "&Open...";
            this.fileOpenMenuItem.Click += new System.EventHandler(this.fileOpenMenuItem_Click);
            // 
            // menuItem4
            // 
            this.menuItem4.Index = 2;
            this.menuItem4.MergeOrder = 2;
            this.menuItem4.Text = "-";
            // 
            // fileExitMenuItem
            // 
            this.fileExitMenuItem.Index = 3;
            this.fileExitMenuItem.MergeOrder = 2;
            this.fileExitMenuItem.Text = "E&xit";
            this.fileExitMenuItem.Click += new System.EventHandler(this.fileExitMenuItem_Click);
            // 
            // menuItem6
            // 
            this.menuItem6.Index = 1;
            this.menuItem6.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
                                                                                      this.helpAboutMenuItem});
            this.menuItem6.MergeOrder = 2;
            this.menuItem6.Text = "&Help";
            // 
            // helpAboutMenuItem
            // 
            this.helpAboutMenuItem.Index = 0;
            this.helpAboutMenuItem.Text = "About...";
            this.helpAboutMenuItem.Click += new System.EventHandler(this.helpAboutMenuItem_Click);
            // 
            // toolBar1
            // 
            this.toolBar1.Buttons.AddRange(new System.Windows.Forms.ToolBarButton[] {
                                                                                        this._newButton,
                                                                                        this._openButton,
                                                                                        this._saveButton});
            this.toolBar1.DropDownArrows = true;
            this.toolBar1.Name = "toolBar1";
            this.toolBar1.ShowToolTips = true;
            this.toolBar1.Size = new System.Drawing.Size(392, 39);
            this.toolBar1.TabIndex = 1;
            this.toolBar1.ButtonClick += new System.Windows.Forms.ToolBarButtonClickEventHandler(this.toolBar1_ButtonClick);
            // 
            // _newButton
            // 
            this._newButton.Text = "New";
            // 
            // _openButton
            // 
            this._openButton.Text = "Open";
            // 
            // _saveButton
            // 
            this._saveButton.Text = "Save";
            // 
            // MainForm
            // 
            this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
            this.ClientSize = new System.Drawing.Size(392, 342);
            this.Controls.AddRange(new System.Windows.Forms.Control[] {
                                                                          this.toolBar1});
            this.IsMdiContainer = true;
            this.Menu = this.mainMenu1;
            this.Name = "MainForm";
            this.Text = "FileDocument Test";
            this.ResumeLayout(false);

        }
		#endregion

        #region Command Routing
        void NewChild()
        {
            ChildForm child = new ChildForm();
            child.MdiParent = this;
            if( child.NewDocument() ) child.Show();
        }

        void OpenChild()
        {
            ChildForm child = new ChildForm();
            child.MdiParent = this;
            if( child.OpenDocument() ) child.Show();
        }

        void SaveChild()
        {
            ((ChildForm)this.ActiveMdiChild).SaveDocument();
        }
        #endregion

        #region Event Handlers
        private void fileNewMenuItem_Click(object sender, System.EventArgs e)
        {
            NewChild();
        }

        private void fileOpenMenuItem_Click(object sender, System.EventArgs e)
        {
            OpenChild();
        }

        private void fileExitMenuItem_Click(object sender, System.EventArgs e)
        {
            Close();
        }

        private void helpAboutMenuItem_Click(object sender, System.EventArgs e)
        {
            MessageBox.Show("A sample of document management in .NET", "DotNetPad");
        }

        private void toolBar1_ButtonClick(object sender, ToolBarButtonClickEventArgs e)
        {
            if( e.Button == this._newButton ) NewChild();
            else if( e.Button == this._openButton ) OpenChild();
            else if( e.Button == this._saveButton ) SaveChild();
            else Debug.Assert(false);
        }
        #endregion
	}
}
