using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
//using System.Windows.Forms.Design;

namespace FileSearchEngineTest
{
	public delegate void AddTextHandler(string strText);

	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private System.Windows.Forms.Panel panel1;
		private System.Windows.Forms.RichTextBox richTextBox1;
		private System.Windows.Forms.Label lblDir;
		private System.Windows.Forms.CheckBox chkRecursive;
		private System.Windows.Forms.CheckBox chkRegEx;
		private System.Windows.Forms.CheckBox chkAsync;
		private System.Windows.Forms.TextBox txtExpression;
		private System.Windows.Forms.Label lblExpr;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;
		private System.Windows.Forms.Button btnSearch;
		private System.Windows.Forms.TextBox txtDir;
		private System.Windows.Forms.TextBox txtFileTypes;
		private System.Windows.Forms.Label lblFileTypes;
		private System.Windows.Forms.CheckBox chkCase;
		private System.Windows.Forms.CheckBox chkWholeWord;

		private Genghis.FileSearchEngine fseSearch;

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			fseSearch = new Genghis.FileSearchEngine();
			fseSearch.StartProcessing += new Genghis.StartProcessingHandler(this.OnStartProcessing);
			fseSearch.EndProcessing += new Genghis.EndProcessingHandler(this.OnEndProcessing);
			fseSearch.StartFile += new Genghis.StartFileHandler(this.OnStartFile);
			fseSearch.EndFile += new Genghis.EndFileHandler(this.OnEndFile);
			fseSearch.SearchHit += new Genghis.SearchHitHandler(this.OnSearchHit);

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
            this.panel1 = new System.Windows.Forms.Panel();
            this.chkWholeWord = new System.Windows.Forms.CheckBox();
            this.chkCase = new System.Windows.Forms.CheckBox();
            this.lblFileTypes = new System.Windows.Forms.Label();
            this.txtFileTypes = new System.Windows.Forms.TextBox();
            this.btnSearch = new System.Windows.Forms.Button();
            this.lblExpr = new System.Windows.Forms.Label();
            this.txtExpression = new System.Windows.Forms.TextBox();
            this.chkAsync = new System.Windows.Forms.CheckBox();
            this.chkRegEx = new System.Windows.Forms.CheckBox();
            this.chkRecursive = new System.Windows.Forms.CheckBox();
            this.lblDir = new System.Windows.Forms.Label();
            this.txtDir = new System.Windows.Forms.TextBox();
            this.richTextBox1 = new System.Windows.Forms.RichTextBox();
            this.panel1.SuspendLayout();
            this.SuspendLayout();
            // 
            // panel1
            // 
            this.panel1.Controls.AddRange(new System.Windows.Forms.Control[] {
                                                                                 this.chkWholeWord,
                                                                                 this.chkCase,
                                                                                 this.lblFileTypes,
                                                                                 this.txtFileTypes,
                                                                                 this.btnSearch,
                                                                                 this.lblExpr,
                                                                                 this.txtExpression,
                                                                                 this.chkAsync,
                                                                                 this.chkRegEx,
                                                                                 this.chkRecursive,
                                                                                 this.lblDir,
                                                                                 this.txtDir});
            this.panel1.Dock = System.Windows.Forms.DockStyle.Top;
            this.panel1.Name = "panel1";
            this.panel1.Size = new System.Drawing.Size(504, 130);
            this.panel1.TabIndex = 0;
            // 
            // chkWholeWord
            // 
            this.chkWholeWord.Location = new System.Drawing.Point(159, 106);
            this.chkWholeWord.Name = "chkWholeWord";
            this.chkWholeWord.Size = new System.Drawing.Size(115, 18);
            this.chkWholeWord.TabIndex = 7;
            this.chkWholeWord.Text = "Whole Word Only";
            // 
            // chkCase
            // 
            this.chkCase.Location = new System.Drawing.Point(12, 108);
            this.chkCase.Name = "chkCase";
            this.chkCase.Size = new System.Drawing.Size(83, 13);
            this.chkCase.TabIndex = 6;
            this.chkCase.Text = "Match Case";
            // 
            // lblFileTypes
            // 
            this.lblFileTypes.Location = new System.Drawing.Point(15, 61);
            this.lblFileTypes.Name = "lblFileTypes";
            this.lblFileTypes.Size = new System.Drawing.Size(60, 16);
            this.lblFileTypes.TabIndex = 9;
            this.lblFileTypes.Text = "File Types:";
            // 
            // txtFileTypes
            // 
            this.txtFileTypes.Location = new System.Drawing.Point(83, 61);
            this.txtFileTypes.Name = "txtFileTypes";
            this.txtFileTypes.Size = new System.Drawing.Size(242, 20);
            this.txtFileTypes.TabIndex = 2;
            this.txtFileTypes.Text = "*.cs";
            // 
            // btnSearch
            // 
            this.btnSearch.Location = new System.Drawing.Point(358, 11);
            this.btnSearch.Name = "btnSearch";
            this.btnSearch.Size = new System.Drawing.Size(77, 29);
            this.btnSearch.TabIndex = 8;
            this.btnSearch.Text = "Find";
            this.btnSearch.Click += new System.EventHandler(this.btnSearch_Click);
            // 
            // lblExpr
            // 
            this.lblExpr.Location = new System.Drawing.Point(12, 11);
            this.lblExpr.Name = "lblExpr";
            this.lblExpr.Size = new System.Drawing.Size(52, 14);
            this.lblExpr.TabIndex = 6;
            this.lblExpr.Text = "Look For:";
            // 
            // txtExpression
            // 
            this.txtExpression.Location = new System.Drawing.Point(81, 8);
            this.txtExpression.Name = "txtExpression";
            this.txtExpression.Size = new System.Drawing.Size(243, 20);
            this.txtExpression.TabIndex = 0;
            this.txtExpression.Text = "class";
            // 
            // chkAsync
            // 
            this.chkAsync.Checked = true;
            this.chkAsync.CheckState = System.Windows.Forms.CheckState.Checked;
            this.chkAsync.Location = new System.Drawing.Point(318, 84);
            this.chkAsync.Name = "chkAsync";
            this.chkAsync.Size = new System.Drawing.Size(110, 15);
            this.chkAsync.TabIndex = 5;
            this.chkAsync.Text = "Asynchronous";
            // 
            // chkRegEx
            // 
            this.chkRegEx.Location = new System.Drawing.Point(159, 83);
            this.chkRegEx.Name = "chkRegEx";
            this.chkRegEx.Size = new System.Drawing.Size(153, 17);
            this.chkRegEx.TabIndex = 4;
            this.chkRegEx.Text = "Use Regular Expressions";
            // 
            // chkRecursive
            // 
            this.chkRecursive.Checked = true;
            this.chkRecursive.CheckState = System.Windows.Forms.CheckState.Checked;
            this.chkRecursive.Location = new System.Drawing.Point(12, 84);
            this.chkRecursive.Name = "chkRecursive";
            this.chkRecursive.Size = new System.Drawing.Size(122, 14);
            this.chkRecursive.TabIndex = 3;
            this.chkRecursive.Text = "Look In Subfolders";
            // 
            // lblDir
            // 
            this.lblDir.Location = new System.Drawing.Point(14, 36);
            this.lblDir.Name = "lblDir";
            this.lblDir.Size = new System.Drawing.Size(51, 16);
            this.lblDir.TabIndex = 1;
            this.lblDir.Text = "Look In:";
            // 
            // txtDir
            // 
            this.txtDir.Location = new System.Drawing.Point(82, 34);
            this.txtDir.Name = "txtDir";
            this.txtDir.Size = new System.Drawing.Size(243, 20);
            this.txtDir.TabIndex = 1;
            this.txtDir.Text = "c:\\";
            this.txtDir.TextChanged += new System.EventHandler(this.textBox1_TextChanged);
            // 
            // richTextBox1
            // 
            this.richTextBox1.Dock = System.Windows.Forms.DockStyle.Fill;
            this.richTextBox1.Location = new System.Drawing.Point(0, 130);
            this.richTextBox1.Name = "richTextBox1";
            this.richTextBox1.Size = new System.Drawing.Size(504, 251);
            this.richTextBox1.TabIndex = 0;
            this.richTextBox1.Text = "richTextBox1";
            // 
            // Form1
            // 
            this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
            this.ClientSize = new System.Drawing.Size(504, 381);
            this.Controls.AddRange(new System.Windows.Forms.Control[] {
                                                                          this.richTextBox1,
                                                                          this.panel1});
            this.Name = "Form1";
            this.Text = "Form1";
            this.Closing += new System.ComponentModel.CancelEventHandler(this.Form1_Closing);
            this.panel1.ResumeLayout(false);
            this.ResumeLayout(false);

        }
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

		private void btnFolderDlg_Click(object sender, System.EventArgs e)
		{
			
		}

		private void textBox1_TextChanged(object sender, System.EventArgs e)
		{
		
		}

		private void btnSearch_Click(object sender, System.EventArgs e)
		{			
            if (fseSearch.State == Genghis.SearchState.Running)
            {
                fseSearch.Stop();
                btnSearch.Text = "Search";
            }
            else
            {
                richTextBox1.Clear();
                fseSearch.Asynchronous= chkAsync.Checked;
                fseSearch.Recursive = chkRecursive.Checked;
                fseSearch.UseRegEx = chkRegEx.Checked;
                fseSearch.Expression = txtExpression.Text;
                fseSearch.StartDirectory = txtDir.Text;
                fseSearch.WildCard = txtFileTypes.Text;
                fseSearch.MatchCase = chkCase.Checked;
                fseSearch.WholeWord = chkWholeWord.Checked;

                if (chkAsync.Checked)
                {
                    btnSearch.Text = "Stop";
                }

                fseSearch.Search();
            }

		}

		private void OnStartProcessing(object sender)
		{
			
		}

		private void OnEndProcessing(object sender)
		{
            if (chkAsync.Checked)
            {
                ThreadSafeChangeCaption("Find");
            }
		}

		private void OnStartFile(string strFilePath)
		{

		}

		private void OnEndFile(string strFilePath)
		{
			
		} 

		private void OnSearchHit(Genghis.SearchHitArgs args)
		{
			ThreadSafeAddText(args.FilePath + " (" + args.LineNumber.ToString() + ", " + args.ColumnNumber.ToString() + "): " + args.LineText);
		}

		private void OnSearchException(Genghis.SearchExceptionArgs args)
		{
			ThreadSafeAddText("Error searching file " + args.FilePath + ": " + args.SourceException.Message);
		}

		private void ThreadSafeAddText(string strText)
		{
			object[] objs = new Object[]{strText};
			richTextBox1.Invoke(new AddTextHandler(OnAddText), objs);
		}

        private void ThreadSafeChangeCaption(string strText)
        {
            object[] objs = new Object[]{strText};
            btnSearch.Invoke(new AddTextHandler(OnChangeCaption), objs);
        }

		private void OnAddText(string strText)
		{
			richTextBox1.AppendText(strText + "\r\n");
		}

        private void OnChangeCaption(string strText)
        {
            btnSearch.Text = strText;
        }

        private void Form1_Closing(object sender, System.ComponentModel.CancelEventArgs e)
        {
            if (fseSearch.State == Genghis.SearchState.Running)
            {
                fseSearch.Stop();
            }
        }
	}
}
