using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;

using System.IO;

using Genghis.Windows.Forms;

namespace ImageComboTest
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private Genghis.Windows.Forms.ImageCombo comboBox1;
		private System.Windows.Forms.ImageList imageList1;
		private System.ComponentModel.IContainer components;

		protected class DirItem
		{
			public DirItem(int imageIndex, int indent, string path)
			{
				this.imageIndex = imageIndex;
				this.indent = indent;
				this.path = path;
			}

			public override string ToString()
			{
				return Path; 
			}

			public string Path
			{
				get { return path; }
			}

			public string SubPath
			{
				get
				{
					int i = Path.IndexOf('\\');
					return (i != -1 ? path.Substring(i+1) : path);
				}
			}

			public int Indent
			{
				get { return indent; }
			}

			public int ImageIndex
			{
				get { return imageIndex; }
			}

			int				indent;
			int				imageIndex;
			string			path;
		}

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();
						
			comboBox1.Items.Add(new DirItem(0, 0, "My computer"));
			string[] dirs = Directory.GetDirectories(@"c:\");
			foreach(string dir in dirs)
				comboBox1.Items.Add(new DirItem(1, 10, dir));

		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
            this.components = new System.ComponentModel.Container();
            System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(Form1));
            this.imageList1 = new System.Windows.Forms.ImageList(this.components);
            this.comboBox1 = new Genghis.Windows.Forms.ImageCombo();
            this.SuspendLayout();
            // 
            // imageList1
            // 
            this.imageList1.ColorDepth = System.Windows.Forms.ColorDepth.Depth8Bit;
            this.imageList1.ImageSize = new System.Drawing.Size(16, 16);
            this.imageList1.ImageStream = ((System.Windows.Forms.ImageListStreamer)(resources.GetObject("imageList1.ImageStream")));
            this.imageList1.TransparentColor = System.Drawing.Color.Transparent;
            // 
            // comboBox1
            // 
            this.comboBox1.DisplayMember = "SubPath";
            this.comboBox1.DrawMode = System.Windows.Forms.DrawMode.OwnerDrawFixed;
            this.comboBox1.ImageList = this.imageList1;
            this.comboBox1.ImageMember = "ImageIndex";
            this.comboBox1.IndentMember = "Indent";
            this.comboBox1.Location = new System.Drawing.Point(48, 32);
            this.comboBox1.Name = "comboBox1";
            this.comboBox1.SelectedImageMember = "";
            this.comboBox1.Size = new System.Drawing.Size(304, 21);
            this.comboBox1.TabIndex = 0;
            this.comboBox1.Text = "comboBox1";
            // 
            // Form1
            // 
            this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
            this.ClientSize = new System.Drawing.Size(400, 94);
            this.Controls.AddRange(new System.Windows.Forms.Control[] {
                                                                          this.comboBox1});
            this.Name = "Form1";
            this.Text = "Form1";
            this.ResumeLayout(false);

        }
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}
	}
}
