using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.IO;
using System.IO.IsolatedStorage;
using System.Reflection;
using System.Text.RegularExpressions;
using Genghis.Windows.Forms;

/// <summary>
/// Summary description for MRU.
/// </summary>
public class SubMenuMRUForm : System.Windows.Forms.Form
{
	/// <summary>
	/// Required designer variable.
	/// </summary>
	private System.ComponentModel.Container components = null;
    private System.Windows.Forms.MainMenu menuBar;
    private System.Windows.Forms.MenuItem cmdFile;
    private System.Windows.Forms.MenuItem cmdExit;
    private System.Windows.Forms.MenuItem cmdRecentlyUsedSubMenu;
    private System.Windows.Forms.Button btnAddMenuItem;
    private System.Windows.Forms.Button cmdClearMenuItems;
    private System.Windows.Forms.TextBox txtCapacity;
    private System.Windows.Forms.Button cmdSetCapacity;
    private System.Windows.Forms.Label label2;
    private System.Windows.Forms.StatusBar statusBar;
    private System.Windows.Forms.StatusBarPanel pnlMenuItemCount;
    private System.Windows.Forms.MenuItem menuItem1;
    
	public SubMenuMRUForm()
	{
		//
		// Required for Windows Form Designer support
		//
		InitializeComponent();

		//
		// TODO: Add any constructor code after InitializeComponent call
		//
	}

	/// <summary>
	/// Clean up any resources being used.
	/// </summary>
	protected override void Dispose( bool disposing )
	{
		if( disposing )
		{
			if(components != null)
			{
				components.Dispose();
			}
		}
		base.Dispose( disposing );
	}
	    
	#region Windows Form Designer generated code
	/// <summary>
	/// Required method for Designer support - do not modify
	/// the contents of this method with the code editor.
	/// </summary>
	private void InitializeComponent()
	{
        this.menuBar = new System.Windows.Forms.MainMenu();
        this.cmdFile = new System.Windows.Forms.MenuItem();
        this.cmdRecentlyUsedSubMenu = new System.Windows.Forms.MenuItem();
        this.menuItem1 = new System.Windows.Forms.MenuItem();
        this.cmdExit = new System.Windows.Forms.MenuItem();
        this.btnAddMenuItem = new System.Windows.Forms.Button();
        this.txtCapacity = new System.Windows.Forms.TextBox();
        this.cmdClearMenuItems = new System.Windows.Forms.Button();
        this.cmdSetCapacity = new System.Windows.Forms.Button();
        this.label2 = new System.Windows.Forms.Label();
        this.statusBar = new System.Windows.Forms.StatusBar();
        this.pnlMenuItemCount = new System.Windows.Forms.StatusBarPanel();
        ((System.ComponentModel.ISupportInitialize)(this.pnlMenuItemCount)).BeginInit();
        this.SuspendLayout();
        // 
        // menuBar
        // 
        this.menuBar.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
                                                                                this.cmdFile});
        // 
        // cmdFile
        // 
        this.cmdFile.Index = 0;
        this.cmdFile.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
                                                                                this.cmdRecentlyUsedSubMenu,
                                                                                this.menuItem1,
                                                                                this.cmdExit});
        this.cmdFile.Text = "&File";
        // 
        // cmdRecentlyUsedSubMenu
        // 
        this.cmdRecentlyUsedSubMenu.Index = 0;
        this.cmdRecentlyUsedSubMenu.Text = "&Sub Menu MRU";
        // 
        // menuItem1
        // 
        this.menuItem1.Index = 1;
        this.menuItem1.Text = "-";
        // 
        // cmdExit
        // 
        this.cmdExit.Index = 2;
        this.cmdExit.Text = "E&xit";
        this.cmdExit.Click += new System.EventHandler(this.cmdExit_Click);
        // 
        // btnAddMenuItem
        // 
        this.btnAddMenuItem.Location = new System.Drawing.Point(16, 16);
        this.btnAddMenuItem.Name = "btnAddMenuItem";
        this.btnAddMenuItem.Size = new System.Drawing.Size(104, 23);
        this.btnAddMenuItem.TabIndex = 0;
        this.btnAddMenuItem.Text = "Add Menu Item";
        this.btnAddMenuItem.Click += new System.EventHandler(this.btnAddMenuItem_Click);
        // 
        // txtCapacity
        // 
        this.txtCapacity.Location = new System.Drawing.Point(64, 80);
        this.txtCapacity.Name = "txtCapacity";
        this.txtCapacity.Size = new System.Drawing.Size(88, 20);
        this.txtCapacity.TabIndex = 4;
        this.txtCapacity.Text = "12";
        // 
        // cmdClearMenuItems
        // 
        this.cmdClearMenuItems.Location = new System.Drawing.Point(16, 48);
        this.cmdClearMenuItems.Name = "cmdClearMenuItems";
        this.cmdClearMenuItems.Size = new System.Drawing.Size(104, 23);
        this.cmdClearMenuItems.TabIndex = 5;
        this.cmdClearMenuItems.Text = "Clear Menu Items";
        this.cmdClearMenuItems.Click += new System.EventHandler(this.cmdClearMenuItems_Click);
        // 
        // cmdSetCapacity
        // 
        this.cmdSetCapacity.Location = new System.Drawing.Point(160, 79);
        this.cmdSetCapacity.Name = "cmdSetCapacity";
        this.cmdSetCapacity.Size = new System.Drawing.Size(104, 23);
        this.cmdSetCapacity.TabIndex = 6;
        this.cmdSetCapacity.Text = "Set Capacity";
        this.cmdSetCapacity.Click += new System.EventHandler(this.cmdSetCapacity_Click);
        // 
        // label2
        // 
        this.label2.Location = new System.Drawing.Point(13, 83);
        this.label2.Name = "label2";
        this.label2.Size = new System.Drawing.Size(100, 16);
        this.label2.TabIndex = 7;
        this.label2.Text = "Capacity:";
        // 
        // statusBar
        // 
        this.statusBar.Location = new System.Drawing.Point(0, 125);
        this.statusBar.Name = "statusBar";
        this.statusBar.Panels.AddRange(new System.Windows.Forms.StatusBarPanel[] {
                                                                                     this.pnlMenuItemCount});
        this.statusBar.ShowPanels = true;
        this.statusBar.Size = new System.Drawing.Size(282, 22);
        this.statusBar.SizingGrip = false;
        this.statusBar.TabIndex = 8;
        this.statusBar.Text = "Ready";
        // 
        // pnlMenuItemCount
        // 
        this.pnlMenuItemCount.AutoSize = System.Windows.Forms.StatusBarPanelAutoSize.Spring;
        this.pnlMenuItemCount.Text = "Sub Menu Item Count: {0}";
        this.pnlMenuItemCount.Width = 282;
        // 
        // SubMenuMRUForm
        // 
        this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
        this.ClientSize = new System.Drawing.Size(282, 147);
        this.Controls.AddRange(new System.Windows.Forms.Control[] {
                                                                      this.statusBar,
                                                                      this.txtCapacity,
                                                                      this.label2,
                                                                      this.cmdSetCapacity,
                                                                      this.cmdClearMenuItems,
                                                                      this.btnAddMenuItem});
        this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedSingle;
        this.MaximizeBox = false;
        this.MaximumSize = new System.Drawing.Size(288, 192);
        this.Menu = this.menuBar;
        this.MinimizeBox = false;
        this.MinimumSize = new System.Drawing.Size(288, 192);
        this.Name = "SubMenuMRUForm";
        this.ShowInTaskbar = false;
        this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
        this.Text = "Sub Menu MRU Test Client";
        this.Load += new System.EventHandler(this.MainForm_Load);
        this.Closed += new System.EventHandler(this.MainForm_Closed);
        ((System.ComponentModel.ISupportInitialize)(this.pnlMenuItemCount)).EndInit();
        this.ResumeLayout(false);

    }
	#endregion
  
    #region Application and User Settings
    
    private void LoadSettings()
    {
        try
        {
            using( Stream         stream = OpenSettingsStream() )
            using( StreamReader   reader = new StreamReader(stream) )
            {
                // Rehydrate MRU
                int   mruCount = (int)ReadSetting(reader, typeof(int));
                if( mruCount > 0 )
                {
                    for( int fileIndex = 1; fileIndex <= mruCount; fileIndex++ ) AddMRUFile((string)ReadSetting(reader, typeof(string)));
                    _filesAdded = mruCount;
                }
            }
        }
        catch {}
    }

    private void SaveSettings()
    {
        using( Stream         stream = CreateSettingsStream() )
        using( StreamWriter   writer = new StreamWriter(stream) )
        {   
            // Persist MRU
            if( _subMenuMRU.Count > 0 )
            {
                WriteSetting(writer, _subMenuMRU.Count);
                for( int fileIndex = _subMenuMRU.Count - 1; fileIndex >= 0; fileIndex-- )
                {
                    WriteSetting(writer, _subMenuMRU.GetFileName(fileIndex));
                }
            }
        }
    }

    private IsolatedStorageFileStream CreateSettingsStream()
    {
        IsolatedStorageFile store = IsolatedStorageFile.GetUserStoreForDomain();
        return new IsolatedStorageFileStream(_settingsFileName, FileMode.Create, store);
    }

    private IsolatedStorageFileStream OpenSettingsStream()
    {
        IsolatedStorageFile store = IsolatedStorageFile.GetUserStoreForDomain();
        return new IsolatedStorageFileStream(_settingsFileName, FileMode.Open, store);
    }

    private object ReadSetting(StreamReader reader, Type type)
    {
        TypeConverter   converter = TypeDescriptor.GetConverter(type);
        return converter.ConvertFromString(reader.ReadLine());
    }

    private void WriteSetting(StreamWriter writer, object obj)
    {
        TypeConverter   converter = TypeDescriptor.GetConverter(obj.GetType());
        writer.WriteLine(converter.ConvertToString(obj));
    }
    #endregion
    
    #region Event Handlers   

    private void MainForm_Load(object sender, System.EventArgs e)
    {
        _subMenuMRU = new MRU(MRUMenuLocation.InSubMenu, 12, "Recently Used Files", 40, cmdRecentlyUsedSubMenu, new System.EventHandler(InMenuMRUClickEventHandler));
        LoadSettings();
        pnlMenuItemCount.Text = string.Format(_menuItemCountFormat, _subMenuMRU.Count, _subMenuMRU.Capacity);
    }

    private void MainForm_Closed(object sender, System.EventArgs e)
    {
        SaveSettings();
    }

    private void InMenuMRUClickEventHandler(object sender, System.EventArgs e)
    {
        MenuItem   mi = (MenuItem) sender;
        MessageBox.Show("File Selected: " + _subMenuMRU.GetFileName(mi.Index));
    }

    private void cmdExit_Click(object sender, System.EventArgs e)
    {
        Close();
    }
    
    private void btnAddMenuItem_Click(object sender, System.EventArgs e)
    {
        _filesAdded++;
        AddMRUFile(Assembly.GetExecutingAssembly().Location  + _filesAdded.ToString());   
    }

    private void cmdClearMenuItems_Click(object sender, System.EventArgs e)
    {
        _subMenuMRU.Clear();
        UpdatePanel();
    }
    
    private void cmdSetCapacity_Click(object sender, System.EventArgs e)
    {
        // Is valid capacity?
        Regex   re = new Regex(@"^[1-9]\d*$", RegexOptions.None);
        if( !re.IsMatch(txtCapacity.Text) )
        {
            MessageBox.Show("Capacity must be a number greater than 0.");
            txtCapacity.SelectAll();
            txtCapacity.Focus();
            return;
        }
        
        // Set new capacity
        _subMenuMRU.Capacity = Convert.ToInt32(txtCapacity.Text);
        UpdatePanel();
    }
    
    #endregion    
    
    private void AddMRUFile(string mruFileName)
    {
        _subMenuMRU.Add(mruFileName);
        UpdatePanel();
    }
       
    private void UpdatePanel()
    {
        pnlMenuItemCount.Text = string.Format(_menuItemCountFormat, _subMenuMRU.Count, _subMenuMRU.Capacity);
    }
    
    const string   _settingsFileName = "_subMenuMRUsettings.txt";
    const int      _maxMRUFiles = 12;
    int            _filesAdded = 0;
    string         _menuItemCountFormat = "Sub Menu Item Count: {0} of {1} Maximum";
    MRU            _subMenuMRU;
}