using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using Genghis;
using Genghis.Win32;

namespace PathResolverTest
{

	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private Genghis.PathResolver	pathResolver = new Genghis.PathResolver();
		private ShareMap myShares = null;
		private System.Windows.Forms.TextBox textBox1;
		private MappedDriveMap myMaps = null;
		private System.Windows.Forms.ProgressBar progressBar1;
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.Label label2;
		private System.Windows.Forms.TextBox textMaps;
		private System.Windows.Forms.TextBox textShares;
		private System.Windows.Forms.Button btnTest;

		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//tie up the events
			SystemShares.SharesChanged += new SystemSharesSharesChangedEventHandler(this.ShareFinder_SharesChanged);
			MappedDrives.MappedDrivesChanged += new MappedDrivesChangedEventHandler(this.mappedDrives_MappedDrivesChanged);
			pathResolver.PathResolved += new Genghis.PathResolvedEventHandler(this.pathResolver_ResolvedPath);

			//to fix appendtext bug
			textBox1.SelectionStart=textBox1.Text.Length;
			textBox1.SelectionLength=0;
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.textBox1 = new System.Windows.Forms.TextBox();
			this.progressBar1 = new System.Windows.Forms.ProgressBar();
			this.textMaps = new System.Windows.Forms.TextBox();
			this.textShares = new System.Windows.Forms.TextBox();
			this.label1 = new System.Windows.Forms.Label();
			this.label2 = new System.Windows.Forms.Label();
			this.btnTest = new System.Windows.Forms.Button();
			this.SuspendLayout();
			// 
			// textBox1
			// 
			this.textBox1.Dock = System.Windows.Forms.DockStyle.Top;
			this.textBox1.Multiline = true;
			this.textBox1.Name = "textBox1";
			this.textBox1.ScrollBars = System.Windows.Forms.ScrollBars.Vertical;
			this.textBox1.Size = new System.Drawing.Size(400, 304);
			this.textBox1.TabIndex = 0;
			this.textBox1.Text = "";
			// 
			// progressBar1
			// 
			this.progressBar1.Dock = System.Windows.Forms.DockStyle.Bottom;
			this.progressBar1.Location = new System.Drawing.Point(0, 553);
			this.progressBar1.Name = "progressBar1";
			this.progressBar1.Size = new System.Drawing.Size(400, 23);
			this.progressBar1.TabIndex = 2;
			// 
			// textMaps
			// 
			this.textMaps.Anchor = ((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right);
			this.textMaps.Location = new System.Drawing.Point(0, 352);
			this.textMaps.Multiline = true;
			this.textMaps.Name = "textMaps";
			this.textMaps.ScrollBars = System.Windows.Forms.ScrollBars.Vertical;
			this.textMaps.Size = new System.Drawing.Size(400, 88);
			this.textMaps.TabIndex = 3;
			this.textMaps.Text = "";
			// 
			// textShares
			// 
			this.textShares.Anchor = ((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right);
			this.textShares.Location = new System.Drawing.Point(0, 472);
			this.textShares.Multiline = true;
			this.textShares.Name = "textShares";
			this.textShares.ScrollBars = System.Windows.Forms.ScrollBars.Vertical;
			this.textShares.Size = new System.Drawing.Size(400, 80);
			this.textShares.TabIndex = 4;
			this.textShares.Text = "";
			// 
			// label1
			// 
			this.label1.Anchor = ((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right);
			this.label1.Location = new System.Drawing.Point(0, 328);
			this.label1.Name = "label1";
			this.label1.TabIndex = 5;
			this.label1.Text = "Maps";
			// 
			// label2
			// 
			this.label2.Anchor = ((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right);
			this.label2.Location = new System.Drawing.Point(0, 448);
			this.label2.Name = "label2";
			this.label2.TabIndex = 6;
			this.label2.Text = "Shares";
			// 
			// btnTest
			// 
			this.btnTest.Location = new System.Drawing.Point(312, 320);
			this.btnTest.Name = "btnTest";
			this.btnTest.TabIndex = 7;
			this.btnTest.Text = "Click Me";
			this.btnTest.Click += new System.EventHandler(this.btnTest_Click);
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(6, 15);
			this.ClientSize = new System.Drawing.Size(400, 576);
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		  this.btnTest,
																		  this.label2,
																		  this.label1,
																		  this.textShares,
																		  this.textMaps,
																		  this.progressBar1,
																		  this.textBox1});
			this.Name = "Form1";
			this.Text = "Form1";
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
			
			//System.Uri testURI = new System.Uri("\\\\hyperion\\tasty");
			//System.Windows.Forms.MessageBox.Show(testURI.IsUnc.ToString() + " " + testURI.LocalPath + Environment.NewLine + testURI.AbsoluteUri + Environment.NewLine + testURI.Query);
			//System.Windows.Forms.MessageBox.Show("

		}

		private void ResolvePathLocalTests()
		{
			Genghis.PathList pathList = new Genghis.PathList();

			//1) From non-mapped remote UNC
			ResolvePathLocal("\\\\Ps-w2kdc1\\MBE");
			ResolvePathLocal("\\\\Ps-w2kdc1\\MBE\\Default.htm");
			pathList.Add("\\\\Ps-w2kdc1\\MBE");
			pathList.Add("\\\\PS-W2Kdc1\\MBE");
			pathList.Add("\\\\Ps-w2kdc1\\MBE\\Default.htm");

			//2) From mapped remote UNC
			ResolvePathLocal("\\\\Ps-w2kdc1\\Inetpub");						//e:\
			ResolvePathLocal("\\\\Ps-w2kdc1\\Inetpub\\Scripts\\S4.exe");	//e:\Scripts\S4.exe
			pathList.Add("\\\\Ps-w2kdc1\\Inetpub");
			pathList.Add("\\\\Ps-w2kdc1\\Inetpub\\Scripts\\S4.exe");

			//3) From local machine UNC
			ResolvePathLocal("\\\\pw-brown\\download");				//c:\download
			ResolvePathLocal("\\\\pw-brown\\download\\dir.txt");	//c:\download\dir.txt
			pathList.Add("\\\\pw-brown\\download");
			pathList.Add("\\\\pw-brown\\download\\dir.txt");

			//4) From local shared drive
			ResolvePathLocal("c:\\download");						//c:\download
			ResolvePathLocal("c:\\download\\dir.txt");				//c:\download\dir.txt
			pathList.Add("c:\\download");
			pathList.Add("c:\\download\\dir.txt");

			//5) From local SUBST'd drive that's shared
			ResolvePathLocal("g:\\download");						//c:\download
			ResolvePathLocal("g:\\download\\dir.txt");				//c:\download\dir.txt
			pathList.Add("g:\\download");
			pathList.Add("g:\\download\\dir.txt");

			//6) From local SUBST'd drive that's not shared
			/* */ResolvePathLocal("g:\\");							//c:\
			/* */ResolvePathLocal("g:\\notepad.txt");				//c:\notepad.txt
			pathList.Add("g:\\");
			pathList.Add("g:\\notepad.txt");

			//7) From local mapped drive
			ResolvePathLocal("e:\\Scripts");						//e:\Scripts
			ResolvePathLocal("e:\\Scripts\\S4.exe");				//e:\Scripts\S4.exe
			pathList.Add("e:\\Scripts");
			pathList.Add("e:\\Scripts\\S4.exe");

			//8) From local network-inaccesible drive
			ResolvePathLocal("c:\\");								//c:\
			ResolvePathLocal("c:\\notepad.txt");					//c:\notepad.txt
			pathList.Add("c:\\");
			pathList.Add("c:\\notepad.txt");

			textBox1.AppendText(Environment.NewLine);
			Genghis.IResolvedPathList resolvedPathList = pathResolver.ResolvePathList(pathList, Genghis.PathResolveTypeEnum.Local);

			
			foreach (string UNC in pathList)
			//foreach (string UNC in resolvedPathList.Keys)
			{
				//foreach (string local in resolvedPathList[UNC])
				//{
					textBox1.AppendText("UNC path " + UNC + " resolved as local : " + resolvedPathList[UNC] + Environment.NewLine);
				//}
			}


		}

		private void ResolvePathUNCTests()
		{
			Genghis.PathList pathList = new Genghis.PathList();

			//1) From remote machine UNC
			ResolvePathUNC("\\\\Ps-w2kdc1\\MBE");					//\\Ps-w2kdc1\MBE
			ResolvePathUNC("\\\\Ps-w2kdc1\\MBE\\Default.htm");		//\\Ps-w2kdc1\MBE\Default.htm
			pathList.Add("\\\\Ps-w2kdc1\\MBE");
			pathList.Add("\\\\Ps-w2kdc1\\MBE\\Default.htm");

			//2) From mapped remote UNC
			ResolvePathUNC("\\\\Ps-w2kdc1\\Inetpub");				//\\ps-w2kdc1\Inetpub
			ResolvePathUNC("\\\\Ps-w2kdc1\\Inetpub\\Scripts\\S4.exe");	//\\Ps-w2kdc1\Inetpub\Scripts\S4.exe
			pathList.Add("\\\\Ps-w2kdc1\\Inetpub");
			pathList.Add("\\\\Ps-w2kdc1\\Inetpub\\Scripts\\S4.exe");

			//3) From local machine UNC
			ResolvePathUNC("\\\\pw-brown\\download");				//\\pw-brown\download
			ResolvePathUNC("\\\\pw-brown\\download\\dir.txt");		//\\pw-brown\download\dir.txt
			pathList.Add("\\\\pw-brown\\download");
			pathList.Add("\\\\pw-brown\\download\\dir.txt");

			//4) From Local shared drive
			ResolvePathUNC("c:\\download");							//\\pw-brown\download
			ResolvePathUNC("c:\\download\\dir.txt");				//\\pw-brown\download\dir.txt
			pathList.Add("c:\\download");
			pathList.Add("c:\\download\\dir.txt");

			//5) From local SUBST'd drive that's shared
			ResolvePathUNC("g:\\download");							//\\pw-brown\download
			ResolvePathUNC("g:\\download\\dir.txt");				//\\pw-brown\download\dir.txt
			pathList.Add("g:\\download");
			pathList.Add("c:\\download\\dir.txt");

			//6) From local SUBST'd drive that's not shared
			ResolvePathUNC("g:\\");
			ResolvePathUNC("g:\\notepad.txt");
			pathList.Add("g:\\");
			pathList.Add("g:\\notepad.txt");

			//7) From local mapped drive
			ResolvePathUNC("e:\\Scripts");							//\\Ps-w2kdc1\Inetpub\Scripts
			ResolvePathUNC("e:\\Scripts\\S4.exe");					//\\Ps-w2kdc1\Inetpub\Scripts\S4.exe
			pathList.Add("e:\\Scripts");
			pathList.Add("e:\\Scripts\\S4.exe");

			//8) From local network-inaccesible drive
			ResolvePathUNC("c:\\");
			ResolvePathUNC("c:\\notepad.txt");
			pathList.Add("c:\\");
			pathList.Add("c:\\notepad.txt");

			textBox1.AppendText(Environment.NewLine);
			Genghis.IResolvedPathList resolvedPathList = pathResolver.ResolvePathList(pathList, Genghis.PathResolveTypeEnum.UNC);

			foreach (string local in pathList)
			{
				//foreach (string UNC in resolvedPathList[local])
				//{
					textBox1.AppendText("Local path " + local + " resolved as UNC : " + resolvedPathList[local] + Environment.NewLine);
				//}
			}
			
		}



		private void ResolvePathLocal(string UNC)
		{
			textBox1.AppendText("UNC path " + UNC + " resolved as local : " + pathResolver.ResolvePath(UNC, Genghis.PathResolveTypeEnum.Local) + Environment.NewLine);
		}

		private void ResolvePathUNC(string local)
		{
			textBox1.AppendText("Local path " + local + " resolved as UNC : " + pathResolver.ResolvePath(local, Genghis.PathResolveTypeEnum.UNC) + Environment.NewLine);
		}


		//the shares have changed
		protected void ShareFinder_SharesChanged(object sender, System.EventArgs e)
		{
			myShares = SystemShares.Shares;
			textShares.AppendText(Environment.NewLine + "Share added or removed! Current share list:" + Environment.NewLine);
			foreach (string shareName in myShares.Keys)
			{
				textShares.AppendText("Share : " + shareName + " - Path : " + myShares[shareName] + Environment.NewLine);
			}
		}

		protected void mappedDrives_MappedDrivesChanged(object sender, System.EventArgs e)
		{
			myMaps = MappedDrives.Maps;
			textMaps.AppendText(Environment.NewLine + "Map added or removed!  Current map list:" + Environment.NewLine);
			foreach (string map in myMaps.Keys)
			{
				textMaps.AppendText("Mapped drive : " + myMaps[map] + " - Path : " + map + Environment.NewLine);
			}			
		}

		private void pathResolver_ResolvedPath(object sender, Genghis.PathResolverEventArgs e)
		{
			if (!this.progressBar1.InvokeRequired)
			{
				this.progressBar1.Maximum = e.Total -1;
				this.progressBar1.Value = e.CurrentIndex;
			}
		}

		private void btnTest_Click(object sender, System.EventArgs e)
		{
			textShares.AppendText("Initial Shares" + Environment.NewLine);
			myShares = SystemShares.Shares;
			foreach (string shareName in myShares.Keys)
			{
				textShares.AppendText("Share : " + shareName + " - Path : " + myShares[shareName] + Environment.NewLine);
			}
			textShares.AppendText(Environment.NewLine);

			textMaps.AppendText("Initial Maps" + Environment.NewLine);
			myMaps = MappedDrives.Maps;
			foreach (string map in myMaps.Keys)
			{
				textMaps.AppendText("Mapped drive : " + myMaps[map] + " - Path : " + map + Environment.NewLine);
			}
			textMaps.AppendText(Environment.NewLine);


			ResolvePathLocalTests();
			textBox1.AppendText(Environment.NewLine);
			ResolvePathUNCTests();		
		}
	}
}
