using System;
using System.IO;
using System.Windows.Forms;
using Genghis.DocView;

class SimplePadDocument : Document {
	string text;

	/// <summary>
	/// Constructs an empty document.</summary>
	public SimplePadDocument() {
		text = "";
	}

	/// <summary>
	/// Deserialization constructor.</summary>
	public SimplePadDocument(Stream stream) : this() {
		StreamReader reader = new StreamReader(stream);
		text = reader.ReadToEnd();
		reader.Close();
	}

	// TODO: Fix this!
	public override string FileDialogFilter {
		get { return "SimplePad documents (*.spd)|*.spd|All files (*.*)|*.*"; }
	}

	public string Text {
		get { return text; }
		set { text = value; Modified = true; }
	}

	/// <summary>
	/// Serialize.</summary>
	public override void Save(Stream stream) {
		StreamWriter writer = new StreamWriter(stream);
		writer.Write(Text);
		writer.Close();
	}
}