/* This file has been automatically generated by TextBox -- DO NOT EDIT! */

/*
Genghis.ViewCollection
Genghis.ViewCollection.Enumerator

These C# classes implement a strongly-typed collection of 
View objects.

The internal representation is an array of View, so the performance 
characteristics will be more like a vector than a list, to use STL terminology.

The implementation is optimized for value-types, as it goes to great length to 
avoid the overhead of boxing and unboxing.  But it should also work well for 
reference types.

Mad props to Nick Wienholt <sheyenne@bigpond.com> for assisting me in 
this research, and the testing, the benchmarking, and of course, the 
implementation!

Last but not least, a quick shout out to Kit George, for his generous 
contribution to the dotnet mailing list -- a code-generator for 
CollectionBase-derived classes:
	http://discuss.develop.com/archives/wa.exe?A2=ind0107C&L=DOTNET&P=R35911
This was the original inspiration for the fine code you are now enjoying.

- Shawn Van Ness, 28 Jan 2002
*/


using System;
using System.Collections;

using T = Genghis.DocView.View;


namespace Genghis.DocView {
	[Serializable]
	public class ViewCollection : ICollection, IList, IEnumerable
	{
		// Construction

		public ViewCollection()
		{ }

		public ViewCollection(ViewCollection x)
		{ AddRange(x); }

		public ViewCollection(T[] x)
		{ AddRange(x); }

		// Operations (type-safe ICollection)

		public int Count
		{
			get
			{ return m_count; }
		}

		public void CopyTo(T[] array)
		{
			this.CopyTo(array, 0);
		}

		public void CopyTo(T[] array, int start)
		{
			if (m_count > array.GetUpperBound(0)+1-start)
				throw new System.ArgumentException("Destination array was not long enough.");
			for (int i=0; i < m_count; ++i)
				array[start+i] = m_array[i];
		}

		// Operations (type-safe IList)

		public T this[int i]
		{
			get
			{
				ValidateIndex(i); // throws
				return m_array[i]; 
			}
			set
			{
				ValidateIndex(i); // throws
				
				OnItemRemoved(m_array[i]);
				
				++m_version;
				m_array[i] = value;
				
				OnItemAdded(value);
			}
		}

		public int Add(T x)
		{
			++m_version;
			
			if (NeedsGrowth())
				Grow();

			m_array[m_count] = x;
			m_count ++;
			
			OnItemAdded(new T[] { x });
			
			return m_count - 1;
		}
		
		public void Clear()
		{
			if (ItemsRemoved != null) {
				T[] members = new T[m_count];
				CopyTo(members);
				OnItemRemoved(members);
			}
		
			++m_version;
			m_array = new T[16];
			m_count = 0;
		}

		public bool Contains(T x)
		{
			for (int i=0; i < m_count; ++i)
				if (m_array[i].Equals(x))
					return true;
			return false;
		}

		public int IndexOf(T x)
		{
			for (int i=0; i < m_count; ++i)
				if (m_array[i].Equals(x))
					return i;
			return -1;
		}

		public void Insert(int pos, T x)
		{
			ValidateIndex(pos,true); // throws
			++m_version;
			
			if (NeedsGrowth())
				Grow();

			for (int i=m_count; i > pos; --i)
				m_array[i] = m_array[i-1];

			m_array[pos] = x;
			m_count++;
			
			OnItemAdded(x);
		}

		public void Remove(T x)
		{			
			int i = IndexOf(x);
			if (i < 0)
				throw new System.ArgumentException("Cannot remove the specified item because it was not found in the specified Collection.");
			
			RemoveAt(i);
		}

		public void RemoveAt(int pos)
		{
			ValidateIndex(pos); // throws
			
			OnItemRemoved(m_array[pos]);
			
			++m_version;
			
			m_count--;
			for (int i=pos; i < m_count; ++i)
				m_array[i] = m_array[i+1];

			if (NeedsTrimming())
				Trim();
		}

		// Operations (type-safe IEnumerable)

		public Enumerator GetEnumerator()
		{
			return new Enumerator(this);
		}

		// Public helpers (just to mimic some nice features of ArrayList)

		public int Capacity
		{
			get
			{ return m_array.Length; }
			set
			{
				++m_version;

				if (value < m_count)
					value = m_count;

				if (value != Capacity)
				{
					T[] temp = new T[value];
					for (int i=0; i < m_count; ++i)
						temp[i] = m_array[i];
					m_array = temp;
				}
			}
		}

		public int AddRange(ViewCollection x)
		{
			++m_version;
			
			int r = m_count;
			for (int i=0; i < x.Count; ++i)
				Add(x[i]);
			
			if (ItemsAdded != null) {
				T[] members = new T[x.Count];
				x.CopyTo(members);
				OnItemAdded(members);
			}
			
			return r;
		}

		public int AddRange(T[] x)
		{
			++m_version;
			
			int r = m_count;
			for (int i=0; i < x.Length; ++i)
				Add(x[i]);
			
			OnItemAdded(x);
			
			return r;
		}

		// Implementation (helpers)

		private void ValidateIndex(int i)
		{
			ValidateIndex(i,false);
		}

		private void ValidateIndex(int i, bool allowEqualEnd)
		{
			int max = (allowEqualEnd)?(m_count):(m_count-1);
			if (i < 0 || i > max)
				throw new System.ArgumentOutOfRangeException("Index was out of range.  Must be non-negative and less than the size of the collection.", (object)i, "Specified argument was out of the range of valid values.");
		}

		private bool NeedsGrowth()
		{
			return (m_count >= Capacity);
		}

		private void Grow()
		{
			++m_version;
			
			if (NeedsGrowth())
			{
				T[] temp = new T[m_count*2];
				for (int i=0; i < m_count; ++i)
					temp[i] = m_array[i];
				m_array = temp;
			}
		}

		private bool NeedsTrimming()
		{
			return (m_count <= Capacity/3);
		}

		private void Trim()
		{
			++m_version;
			
			if (NeedsTrimming())
			{
				T[] temp = new T[m_count];
				for (int i=0; i < m_count; ++i)
					temp[i] = m_array[i];
				m_array = temp;
			}
		}
		
		// Events
		public event ViewCollectionEventHandler ItemsAdded;
		public event ViewCollectionEventHandler ItemsRemoved;
		
		// OnItemAdded is called after the member has been added.
		protected virtual void OnItemAdded(T x) {
			OnItemAdded(new T[] { x });
		}
		protected virtual void OnItemAdded(T[] x) {
			if (ItemsAdded != null)
				ItemsAdded(this, new ViewCollectionEventArgs(true, x));
		}
		
		// OnItemRemoved is called before the member has been removed.
		protected virtual void OnItemRemoved(T x) {
			OnItemRemoved(new T[] { x });
		}
		protected virtual void OnItemRemoved(T[] x) {
			if (ItemsRemoved != null)
				ItemsRemoved(this, new ViewCollectionEventArgs(false, x));
		}
		

		// Implementation (ICollection)

		int ICollection.Count
		{
			get
			{ return m_count; }
		}

		bool ICollection.IsSynchronized
		{
			get
			{ return m_array.IsSynchronized; }
		}

		object ICollection.SyncRoot
		{
			get
			{ return m_array.SyncRoot; }
		}

		void ICollection.CopyTo(Array array, int start)
		{
			this.CopyTo((T[])array, start);
		}

		// Implementation (IList)

		bool IList.IsFixedSize
		{
			get
			{ return false; }
		}

		bool IList.IsReadOnly
		{
			get
			{ return false; }
		}

		object IList.this[int i]
		{
			get
			{ return (object)this[i]; }
			set
			{ this[i] = (T)value; }
		}

		int IList.Add(object x)
		{
			return this.Add((T)x);
		}

		void IList.Clear()
		{
			this.Clear();
		}

		bool IList.Contains(object x)
		{
			return this.Contains((T)x);
		}

		int IList.IndexOf(object x)
		{
			return this.IndexOf((T)x);
		}

		void IList.Insert(int pos, object x)
		{
			this.Insert(pos, (T)x);
		}

		void IList.Remove(object x)
		{
			this.Remove((T)x);
		}

		void IList.RemoveAt(int pos)
		{
			this.RemoveAt(pos);
		}

		// Implementation (IEnumerable)

		IEnumerator IEnumerable.GetEnumerator()
		{
			return (IEnumerator)(this.GetEnumerator());
		}

		// Implementation (data)

		private T[] m_array = new T[16];
		private int m_count = 0;
		private int m_version = 0;

		// Nested enumerator class
		
		public class Enumerator : IEnumerator
		{
			// Construction
	
			public Enumerator(ViewCollection tc)
			{
				m_collection = tc;
				m_index = -1;
				m_version = tc.m_version;
			}
	
			// Operations (type-safe IEnumerator)
	
			public T Current
			{
				get
				{ return m_collection[m_index]; }
			}
	
			public bool MoveNext()
			{
				if (m_version != m_collection.m_version)
					throw new System.InvalidOperationException("Collection was modified; enumeration operation may not execute.");

				++m_index;
				return (m_index < m_collection.Count)?true:false;
			}
	
			public void Reset()
			{
				m_index = -1;
			}
	
			// Implementation (IEnumerator)
	
			object IEnumerator.Current
			{
				get
				{ return (object)(this.Current); }
			}
	
			bool IEnumerator.MoveNext()
			{
				return this.MoveNext();
			}
	
			void IEnumerator.Reset()
			{
				this.Reset();
			}
	
			// Implementation (data)
	
			private ViewCollection m_collection;
			private int m_index;
			private int m_version;
		}
	}
	
	public delegate void ViewCollectionEventHandler(object sender, ViewCollectionEventArgs e);
	
	public class ViewCollectionEventArgs : EventArgs
	{
		bool added;
		T[] items;
		
		public ViewCollectionEventArgs(bool added, T[] items) {
			this.added = added;
			this.items = items;
		}
		
		public T[] Items {
			get { return items; }
		}
		
		public bool Added {
			get { return added; }
		}
	}
	
}
