using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using Genghis.Windows.Forms;

namespace WizardSheetSample
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class mainForm : System.Windows.Forms.Form
	{
    private System.Windows.Forms.Button btnSimpleWizard;
    private System.Windows.Forms.Button btnWizardGroups;
    private System.Windows.Forms.Button btnMixedWizard;
    private System.Windows.Forms.Button btnHelpWizard;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public mainForm()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
      this.btnSimpleWizard = new System.Windows.Forms.Button();
      this.btnWizardGroups = new System.Windows.Forms.Button();
      this.btnMixedWizard = new System.Windows.Forms.Button();
      this.btnHelpWizard = new System.Windows.Forms.Button();
      this.SuspendLayout();
      // 
      // btnSimpleWizard
      // 
      this.btnSimpleWizard.Location = new System.Drawing.Point(8, 8);
      this.btnSimpleWizard.Name = "btnSimpleWizard";
      this.btnSimpleWizard.Size = new System.Drawing.Size(216, 23);
      this.btnSimpleWizard.TabIndex = 0;
      this.btnSimpleWizard.Text = "Show Simple Wizard";
      this.btnSimpleWizard.Click += new System.EventHandler(this.btnSimpleWizard_Click);
      // 
      // btnWizardGroups
      // 
      this.btnWizardGroups.Location = new System.Drawing.Point(8, 72);
      this.btnWizardGroups.Name = "btnWizardGroups";
      this.btnWizardGroups.Size = new System.Drawing.Size(216, 23);
      this.btnWizardGroups.TabIndex = 2;
      this.btnWizardGroups.Text = "Show Wizard with Groups";
      this.btnWizardGroups.Click += new System.EventHandler(this.btnWizardGroups_Click);
      // 
      // btnMixedWizard
      // 
      this.btnMixedWizard.Location = new System.Drawing.Point(8, 104);
      this.btnMixedWizard.Name = "btnMixedWizard";
      this.btnMixedWizard.Size = new System.Drawing.Size(215, 23);
      this.btnMixedWizard.TabIndex = 3;
      this.btnMixedWizard.Text = "Show Wizard with Mixed Pages";
      this.btnMixedWizard.Click += new System.EventHandler(this.btnMixedWizard_Click);
      // 
      // btnHelpWizard
      // 
      this.btnHelpWizard.Location = new System.Drawing.Point(8, 40);
      this.btnHelpWizard.Name = "btnHelpWizard";
      this.btnHelpWizard.Size = new System.Drawing.Size(216, 23);
      this.btnHelpWizard.TabIndex = 1;
      this.btnHelpWizard.Text = "Show Wizard with Help Button";
      this.btnHelpWizard.Click += new System.EventHandler(this.btnHelpWizard_Click);
      // 
      // mainForm
      // 
      this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
      this.ClientSize = new System.Drawing.Size(232, 150);
      this.Controls.AddRange(new System.Windows.Forms.Control[] {
                                                                  this.btnHelpWizard,
                                                                  this.btnMixedWizard,
                                                                  this.btnWizardGroups,
                                                                  this.btnSimpleWizard});
      this.Name = "mainForm";
      this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
      this.Text = "WizardSheet Sample";
      this.ResumeLayout(false);

    }
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new mainForm());
		}

    private void btnSimpleWizard_Click(object sender, System.EventArgs e)
    {
      // Create a WizardSheet to take our Pages
      WizardSheet sheet = new WizardSheet("Simple Wizard");

      // Create a couple of sample pages 
      sheet.AddPage(new SampleWizardPage("First Page", "Description for a page Inherited from WizardPage"));
      sheet.AddPage(new SampleWizardPage("Second Page", "Description for a page Inherited from WizardPage"));

      // Show the Wizard
      if (sheet.ShowDialog() == DialogResult.OK)
      {
        MessageBox.Show("Finished Pushed");
      }
      else
      {
        MessageBox.Show("Cancel Pushed");
      }
    }


    private void btnHelpWizard_Click(object sender, System.EventArgs e)
    {
      // Create a WizardSheet to take our Pages
      SampleWizardSheet sheet = new SampleWizardSheet("Simple Wizard with Help Button");

      // Create a couple of sample pages 
      sheet.AddPage(new SampleWizardPage("First Page", "Description for a page Inherited from WizardPage"));
      sheet.AddPage(new SampleWizardPage("Second Page", "Description for a page Inherited from WizardPage"));

      // Show the Wizard
      if (sheet.ShowDialog() == DialogResult.OK)
      {
        MessageBox.Show("Finished Pushed");
      }
      else
      {
        MessageBox.Show("Cancel Pushed");
      }
    
    }

    private void btnWizardGroups_Click(object sender, System.EventArgs e)
    {
      // Create a WizardSheet to take our Pages
      WizardSheet sheet = new WizardSheet("Simple Wizard with Groups");

      // Create a couple of sample pages 
      sheet.AddPage(new GroupWizardPage(), new string[] {"One", "Two", "Three", "Four"});
      sheet.AddPage(new SampleWizardPage("Group One", "Page 2"), "One");
      sheet.AddPage(new SampleWizardPage("Group Two", "Page 2"), "Two");
      sheet.AddPage(new SampleWizardPage("Group Two", "Page 3"), "Two");
      sheet.AddPage(new SampleWizardPage("Group Three", "Page 2"), "Three");
      sheet.AddPage(new SampleWizardPage("Group Three", "Page 3"), "Three");
      sheet.AddPage(new SampleWizardPage("Group Three", "Page 4"), "Three");
      sheet.AddPage(new SampleWizardPage("Group Four", "Page 2"), "Four");
      sheet.AddPage(new SampleWizardPage("Group Four", "Page 3"), "Four");
      sheet.AddPage(new SampleWizardPage("Group Four", "Page 4"), "Four");
      sheet.AddPage(new SampleWizardPage("Group Four", "Page 5"), "Four");

      // Show the Wizard
      if (sheet.ShowDialog() == DialogResult.OK)
      {
        MessageBox.Show("Finished Pushed");
      }
      else
      {
        MessageBox.Show("Cancel Pushed");
      }
    
    }

    private void btnMixedWizard_Click(object sender, System.EventArgs e)
    {
      // Create a WizardSheet to take our Pages
      WizardSheet sheet = new WizardSheet("Simple Wizard With a Mix of Page Types");

      // Create a couple of sample pages 
      sheet.AddPage(new SampleWizardPage("First Page", "This wizard includes a WizardPage, a combobox, a listbox, a Listview and a TreeView for pages to show that any control can be a Page."));
      
      // Add a ComboBox
      ComboBox cb = new ComboBox();
      cb.Size = new Size(200,200);
      cb.Items.AddRange(new Object[] {"Foo", "Bar"});
      sheet.AddPage(cb);

      // Add a Listbox
      ListBox lb = new ListBox();
      lb.Size = new Size(150,250);
      lb.Items.AddRange(new Object[] {"Foo", "Bar"});
      sheet.AddPage(lb);

      // Add a ListView
      ListView lv = new ListView();
      lv.Size = new Size(200,200);
      lv.Items.Add("An Item");
      sheet.AddPage(lv);

      // Add a TreeView
      TreeView tv = new TreeView();
      tv.Size = new Size(300,100);
      tv.Nodes.Add("ParentNode");
      sheet.AddPage(tv);

      // Show the Wizard
      if (sheet.ShowDialog() == DialogResult.OK)
      {
        MessageBox.Show("Finished Pushed");
      }
      else
      {
        MessageBox.Show("Cancel Pushed");
      }
    }

	}
}
