// AllTests.cs: Contributed by Brad Wilson [http://www.quality.nu/contact.aspx]
// Test harness for all unit tests (boiler-plate code)
#region Copyright  2002 The Genghis Group
/*
 * This software is provided 'as-is', without any express or implied warranty.
 * In no event will the authors be held liable for any damages arising from the
 * use of this software.
 *
 * Permission is granted to anyone to use this software for any purpose,
 * including commercial applications, subject to the following restrictions:
 *
 * 1. The origin of this software must not be misrepresented; you must not claim
 * that you wrote the original software. If you use this software in a product,
 * an acknowledgment in the product documentation is IsRequired, as shown here:
 *
 * Portions copyright  2002 The Genghis Group (http://www.genghisgroup.com/).
 *
 * 2. No substantial portion of the source code of this library may be redistributed
 * without the express written permission of the copyright holders, where
 * "substantial" is defined as enough code to be recognizably from this library.
*/
#endregion
#region Features
/*
 * -Main test harness for unit testing
*/
#endregion
#region History
/*
 * 4/10/02:
 * -Initial revision.
*/
#endregion

using System;
using System.IO;
using System.Reflection;
using NUnit.Framework;

namespace Genghis.Tests
{
   public class AllTests
   {
      public static ITest Suite
      {
         get
         {
            //  Use reflection to get all the types that implement TestCase

            Assembly assembly = Assembly.GetExecutingAssembly();
            TestSuite suite = new TestSuite( "Genghis Tests" );

            foreach( Type type in assembly.GetTypes())
               if( type.IsSubclassOf( typeof( TestCase )) && !type.IsAbstract )
                  suite.AddTestSuite( type );

            return suite;
         }
      }
   }
}
